/*
 * Copyright (c) Huawei Technologies Co., Ltd. 2021-2021. All rights reserved.
 */

package com.huawei.agc.flutter.cloudfunctions;

import androidx.annotation.NonNull;

import com.huawei.agconnect.AGConnectInstance;
import com.huawei.agconnect.function.AGConnectFunction;

import io.flutter.embedding.engine.plugins.FlutterPlugin;
import io.flutter.plugin.common.MethodChannel;

public class AGCCloudFunctionsPlugin implements FlutterPlugin {
    private MethodChannel methodChannel;
    private AGConnectFunction agConnectFunction;

    @Override
    public void onAttachedToEngine(@NonNull final FlutterPluginBinding binding) {
        if (AGConnectInstance.getInstance() == null) {
            AGConnectInstance.initialize(binding.getApplicationContext());
        }
        agConnectFunction = AGConnectFunction.getInstance();
        methodChannel = new MethodChannel(binding.getBinaryMessenger(), "com.huawei.agc.flutter.cloudfunctions/MethodChannel");
        methodChannel.setMethodCallHandler(new CloudFunctionsMethodCallHandler(agConnectFunction));
    }

    @Override
    public void onDetachedFromEngine(@NonNull final FlutterPluginBinding binding) {
        if (methodChannel != null) {
            methodChannel.setMethodCallHandler(null);
            methodChannel = null;
        }
        agConnectFunction = null;
    }
}
