/*
 * Copyright (c) Huawei Technologies Co., Ltd. 2021-2021. All rights reserved.
 */

import 'package:flutter/foundation.dart';

@immutable
class AGCTimeUnit {
  static const NANOSECONDS = const AGCTimeUnit._(0);
  static const MICROSECONDS = const AGCTimeUnit._(1);
  static const MILLISECONDS = const AGCTimeUnit._(2);
  static const SECONDS = const AGCTimeUnit._(3);
  static const MINUTES = const AGCTimeUnit._(4);
  static const HOURS = const AGCTimeUnit._(5);
  static const DAYS = const AGCTimeUnit._(6);

  final int _value;

  const AGCTimeUnit._(this._value);

  factory AGCTimeUnit.fromInt(int value) {
    if (value >= 0 && value <= 6) {
      return AGCTimeUnit._(value);
    } else {
      throw Exception('Value must be in the correct range: -1 < value < 7');
    }
  }

  int toInt() => _value;

  @override
  String toString() => 'AGCTimeUnit(value: $_value)';

  @override
  bool operator ==(Object other) {
    return identical(this, other) ||
        (other is AGCTimeUnit && other._value == _value);
  }

  @override
  int get hashCode => _value.hashCode;
}
