/*
 * Copyright (c) Huawei Technologies Co., Ltd. 2021-2021. All rights reserved.
 */

import 'dart:convert';

import 'package:flutter/foundation.dart';

@immutable
class FunctionResult {
  final String _result;

  const FunctionResult(this._result);

  String getValue() => _result;

  Map<String, dynamic> getMap() => jsonDecode(_result);

  @override
  String toString() => 'FunctionResult(result: $_result)';

  @override
  bool operator ==(Object other) {
    return identical(this, other) ||
        (other is FunctionResult && other._result == _result);
  }

  @override
  int get hashCode => _result.hashCode;
}
